%% Plugins Menu
% This menu allows access to custom plugins. 
%
% The plugins should be placed under
% |mib->Plugins| directory as |PLUGIN_GROUP_NAME/PLUGIN_NAME|, where PLUGIN_GROUP_NAME is a directory with similarly grouped
% plugins. PLUGIN_NAME - is a directory with the actual plugin. The name of controller for each plugin should be formed as: 
% PLUGIN_NAMEController, for example |mytestController.m|. So the full filename
% may look like this:
%
% _c:\MATLAB\Scripts\mib\Plugins\MyPlugings\myPlugin\myPluginController.m_
%
% Please check the contents of |Plugins->Tutorials| for examples. See more in the
% corresponding <http://mib.helsinki.fi/tutorials_programming.html tutorials> .
%
%% File processing
%
% 
% 
% * *Image converter* - a plugin for bulk conversion of files from one
% format to another. A small video tutorial is available via this link 
% <https://youtu.be/Xu1waZ913bE https://youtu.be/Xu1waZ913bE>
% * *ITEM2*
% 
% 
%% Intensity analysis
%
% Plugins for analysis of intensities in images
%
% * *Triple area intensity* - a plugin to calculate intensity in 3 related
% areas in images and calculate the ratios. Click the Help button in the
% plugin for details
%
%% Organelle analysis
%
% Analysis of biological objects
%
% * *MCcalc*, a plugin for detection of contacts and calculation of
% distance distributions from TEM images. See more in the the full MCcalc workflow presented on 
% <http://mib.helsinki.fi/tutorials_tools.html http://mib.helsinki.fi/tutorials_tools.html>
% * *Surface Area 3D* - calculation of surface areas for planar structures
% from MIB models. Use the Help button inside the plugin for details
%
%% Plasmodesmata
%
% Plugins for analysis of plasmadesmata in roots of Arabidopsis thaliana. For details please follow to this publication:
% Paterlini A, Belevich I, Jokitalo E, Helariutta Y., Computational Tools
% for Serial Block Electron Microscopy Reveal Plasmodesmata Distributions and Wall Environments,
% Plant Physiol. 2020 Sep;184(1):53-64. doi: 10.1104/pp.20.00396. Epub 2020 Jul 23.
% <https://pubmed.ncbi.nlm.nih.gov/32719057/ https://pubmed.ncbi.nlm.nih.gov/32719057/>
%
%% Tutorials
%
% Demo examples from the tutorials section: <http://mib.helsinki.fi/tutorials_programming.html http://mib.helsinki.fi/tutorials_programming.html>
%
%
% *Back to* <im_browser_product_page.html *Index*> |*-->*| <im_browser_user_guide.html *User Guide*> |*-->*| <ug_gui_menu.html *Menu*>
%